#include <stdio.h>
#include <errno.h>

char makename[256];

main(arcg,argc)
int argc;
char *argv[];
{

   int ret;

   ret=parse_arguments(argc,argv);
   if(!ret)
   {
      exit(1);
   }
   if(makename[0]=='\0')
   {
      printf("%s",pUsage);
      exit(1);
   }

   /* open the make file */
   mfp=fopen(makefile,"r");
   if(mfp=='\0')
   {
      perror("Make file");
#ifdef VMS
      exit(vaxc$errno);
#else
      exit(errno);
#endif
   }
   /* read the make file */
   flags.branch=FALSE;
   while(!feof(mfp) && !ferror(mfp))
   {
      pline=fgets(line,80,mfp);
      if(pline!='\0')
      {
         /* no branches are open - no targets are open
            parse the line */
         switch(line[0])
         {
            case '!':
               /* comment line - echo if comment echo is set */
               if(flags.echo_comment)
               {
                  printf("%s",line);
               }
               break;
            case '{':
               /* branch open */
               flags.branch=TRUE;
               break;
            case '}':
               /* branch close - only valid if branch is open */
               if(flags.branch)
               {
                  flags.branch=FALSE;
               }
               else
               {
                  ret=print_message("Syntax error - unexpected }");
               }
               break;
            default:
               break;
         }
      }
   }
}

int parse_arguments(argc,argv)
int argc;
char *argv[];
{
   int ret;
   int swtype;
 
   if(argc<1)
      return(TRUE);
 
   while(--argc>=1)
   {
      ++argv;
      swtype=MINUS;
      switch((*argv)[0])
      {
         case '+':
            swtype=PLUS;
         case '-':
            /* a command line switch */
            switch(toupper((*argv)[1]))
            {
               case 'E':
                  /* execute switch */
                  ret=execute_switch(swtype);
                  break;
               case 'D':
                  /* debug switch */
                  ret=debug_switch(swtype);
                  break;
               case 'I':
                  /* Ingres backend flags switch */
                  ret=dbflags_switch(*argv);
                  break;
               case 'Q':
                  ret=query_switch(swtype);
                  break;
               case 'T':
                  /* error trap switch */
                  ret=errtrap_switch(swtype);
                  break;
               default:
                  ret=FALSE;
                  break;
            }
            break;
         default:
            /* a command line argument - 1st must be dbname, 2nd must be formname */
            if(GSingres.dbname[0]=='\0')
               ret=dbname_arg(*argv);
            else
               ret=FALSE;
            break;
      }
   }
 
   return(ret);
}
 
int bell_switch(swtype)
{
 
   switch(swtype)
   {
      case PLUS:
         GScntrl.bellflag=TRUE;
         break;
      case MINUS:
         GScntrl.bellflag=FALSE;
         break;
      default:
         return(FALSE);
         break;
   }
 
   return(TRUE);
}
 
int dbname_arg(pstr)
char *pstr;
{
 
   sprintf(makename,"%s",pstr);
 
   return(TRUE);
}
