$!
$! get state of verify, then turn it off
$!
$ pverifystate=f$environment("VERIFY_PROCEDURE")
$ set verify=(noproc)
$!
$! get state of messages
$!
$ messparam=f$environment("MESSAGE")
$!
$! set up error & control_y trapping
$!
$ set noon
$ exitstat=1
$ reportflag="YES"
$ on control_y then goto eof
$ on severe_error then goto eof
$!
$! give a header
$!
$ makeversion="2.0"
$ write sys$output "VAX/MAKE Version ''makeversion' Started ''f$time()'"
$!
$! set default values
$!
$ PARAM=""
$ ruleno=0
$ lineno=0
$!
$! set default flags
$!
$ FLG$F_C==0     ! 
$ FLG$V_C$T=="M" ! legal values are M (revised date) or C (create date)
$ FLG$V_C$D=="M" ! target & dependent compare dates = C (create date)
$ FLG$F_D==0     ! display dates    = no
$ FLG$F_E==1     ! execute commands = yes
$ FLG$F_I==0     ! ignore errors    = no
$ FLG$F_S==1     ! status messages  = yes
$ FLG$F_V==0     ! command verify   = no
$ FLG$F_R==1     ! report status    = yes
$ FLG$F_P==0     ! parameter        = no
$!
$! parse flags
$!
$ @$tools:flags 'p1' 'p2' 'p3' 'p4' 'p5' 'p6' 'p7' 'p8'
$ checkfile="YES"
$ gosub check_flags
$ if $status .ne. 1 then goto abort
$!
$! execute MAKE$INI if it exists
$!
$ loop=2
$ makeini=f$trnlnm("MAKE$INI")
$ if makeini .eqs. "" then goto outer_loop
$ makeini=f$search(makeini)
$ if makeini .eqs. "" then goto outer_loop
$ loop=1
$!
$! begin reading make file - 1st non-flag argument is the make file name
$!
$ outer_loop:
$ if loop .eq. 1 then makefile=makeini
$ if loop .eq. 2 then makefile=f$parse(ARG1$V,"[]*.MAKE")
$ if statusflag .eqs. "YES" then write sys$output " "
$ if statusflag .eqs. "YES" then write sys$output "VAX/MAKE: Processing MAKE file ''makefile'"
$ open/read file 'makefile'
$ loop:
$ read/error=eof file line
$ lineno=lineno+1
$ parse_line1:
$!
$! look for key characters in 1st column:
$!    !       - comment
$!    %       - flags statement
$!    .       - rule specification
$!    <blank> - skip blank lines
$!    any other character will cause line to be interpreted as a
$!    target spec
$!
$ if f$length(line) .eq. 0 then goto loop
$ if f$extract(0,1,line) .eqs. "%" then goto new_flags
$ if f$extract(0,1,line) .eqs. " " then goto loop
$ if f$extract(0,1,line) .eqs. "!" then goto loop
$ if f$extract(0,1,line) .eqs. "." then goto new_rule
$!
$! if we get here then this is a target spec - turn on rule checking and
$! parse the target
$!
$ rule=1
$ goto do_target
$!
$ new_rule:
$!
$! add this rule to the rules list.  the rules list consists of a series of
$! DCL symbols (created in the user memory pool).  these symbols are as
$! follows:
$!
$!    RULExT    - target file extension
$!    RULExD    - dependent file extension
$!    RULExN    - number of command lines for this rule
$!    RULExLy   - rule command line(s) (1 thru RULExN value)
$!
$! other symbols used in rule storage:
$!
$!    RULENO    - number of currently stored rules
$!
$ t1="."+f$element(1,".",line)
$ t1=f$edit(t1,"UPCASE")
$ !sh sym t1
$ d1="."+f$element(2,".",line)
$ d1=f$edit(d1,"UPCASE")
$ !sh sym d1
$ ruleno=ruleno+1
$ !sh sym ruleno
$!
$! store target extension in RULExT
$!
$ rulename="rule''ruleno't"
$ 'rulename'="''t1'"
$ !sh sym 'rulename'
$!
$! store target extension in RULExD
$!
$ rulename="rule''ruleno'd"
$ 'rulename'="''d1'"
$ !sh sym 'rulename'
$ if statusflag .eqs. "YES" then write sys$output "VAX/MAKE: Found rule for ''t1'''d1'"
$!
$! read rule command lines. set of command lines is terminated by a
$! blank line
$!
$ ruleline=0
$ loop3:
$ read/error=eof file line
$ lineno=lineno+1
$!
$! if 1st character is not a comment character or blank then this line is
$! is not correct - genereate a syntax error
$!
$ if f$length(line) .eq. 0 then goto loop
$ if f$extract(0,1,line) .eqs. "!" then goto loop3
$ if f$extract(0,1,line) .eqs. " " then goto store_ruleline
$ write sys$output " "
$ write sys$output "VAX/MAKE: Syntax error on line ''lineno'"
$ write sys$output "VAX/MAKE: Line is "+line
$ write sys$output "VAX/MAKE: Rules must terminate with a blank line"
$ goto abort
$!
$ store_ruleline:
$!
$! this is a valid command line - store it in RULExLy
$!
$ ruleline=ruleline+1
$ rulename="rule''ruleno'l''ruleline'"
$ 'rulename'=line
$ !sh sym 'rulename'
$ rulename="rule''ruleno'n"
$ 'rulename'='ruleline'
$ !sh sym 'rulename'
$ goto loop3
$!
$ new_flags:
$!
$! parse the flags line and set new flags values
$!
$ flagline="@$tools:flags ''f$extract(1,f$length(line),line)'"
$ !sh sym flagline
$ 'flagline'
$ checkfile="NO"
$ gosub check_flags
$ if $status .ne. 1 then goto abort
$ goto loop
$!
$ do_target:
$!
$! verify that this is a target spec by looking for the : between the
$! target file and dependency list
$!
$ len=f$length(line)
$ colon=f$locate(":",line)
$ if colon .ne. len then goto got_spec
$ write sys$output " "
$ write sys$output "VAX/MAKE: Syntax error on line ''lineno'"
$ write sys$output "VAX/MAKE: Line is "+line
$ write sys$output "VAX/MAKE: Expected target: dependency specification"
$ goto abort
$!
$ got_spec:
$!
$! echo target file name
$!
$ trg=f$element(0,":",line)
$ if statusflag .eqs. "YES" then write sys$output " "
$ if statusflag .eqs. "YES" then write sys$output " "
$ if statusflag .eqs. "YES" then write sys$output "VAX/MAKE: Target is ''trg'"
$!
$ parse_targ:
$!
$! get the target name & extension from the target spec
$! store each in a symbol T1N and T1E (name and extension)
$! these symbols can be given on a command line to refer to the target file
$! name & extension
$!
$ !sh sym trg
$ t1p=f$parse(trg,,,"DEVICE")+f$parse(trg,,,"DIRECTORY")
$ t1n=f$parse(trg,,,"NAME")
$ t1e=f$parse(trg,,,"TYPE")
$ t0=f$element(1,":",line)
$ !sh sym t0
$ element=0
$ compile="NO"
$!
$! turn off error messages in order to execute the directory command to 
$! check the file existance
$!
$ set mess/notext/nosever/nofac/noid
$!
$! execute diectory command to see if the file exists
$!
$ dir/out=nl: 'trg'
$ stat=$status
$!
$! restore error messages
$!
$ set mess'messparam'
$ !sh sym stat
$!
$! check the error status from the directory command - if not 1 then the
$! file does not exist
$!
$ if stat .eq. 1 then goto parse_trgdate
$!
$! target file does not exist - set to compile
$!
$ if statusflag .eqs. "YES" then write sys$output "VAX/MAKE: Target does not exist"
$ compile="YES"
$ trgdval="1-JAN-1900 00:00:00.00"
$ goto parse_dpd
$!
$ parse_trgdate:
$!
$! target file exists
$!
$ trgdval=f$file(trg,trgdat)
$ !sh sym trgdat
$ !sh sym trgdval
$ if statusflag .eqs. "YES" .and. dateflag .eqs. "YES" then write sys$output "VAX/MAKE: Target ''trgdstr' Date is ''trgdval'"
$!
$ parse_dpd:
$!
$! parse the target spec and extract the dependency file names and types
$! there can be any number of dependency files in the list
$! store each in a symbol DxN and DxE (name and extension)
$! these symbols can be given on a command line to refer to the file
$! names & extensions
$!
$ loop1:
$ dpd=f$element(element,",",f$extract(colon+2,f$length(line),line))
$ dpd=f$element(0,"!",dpd)
$ !sh sym dpd
$ element=element+1
$ d'element'p=f$parse(dpd,,,"DEVICE")+f$parse(dpd,,,"DIRECTORY")
$ d'element'n=f$parse(dpd,,,"NAME")
$ d'element'e=f$parse(dpd,,,"TYPE")
$ !sh sym d'element'p
$ !sh sym d'element'n
$ !sh sym d'element'e
$ if dpd .eqs. "," then goto loop1_done
$!
$! check to see if the file exists
$!
$ dpddval=f$parse(dpd)
$ dpddval=f$search(dpddval)
$ if dpddval .nes. "" then goto get_dpd_date
$!
$! file does not exist - skip command lines for this spec
$!
$ if statusflag .eqs. "YES" then write sys$output "VAX/MAKE: Dependency is ''dpd'"
$ if statusflag .eqs. "YES" then write sys$output "VAX/MAKE: Dependency does not exist - can not make target"
$ goto loop
$!
$ get_dpd_date:
$!
$! file exists - get file date (create or modify) for checking against target
$!
$ dpddval=f$file(dpd,dpddat)
$ if statusflag .eqs. "YES" .and. dateflag .eqs. "YES" then write sys$output "VAX/MAKE: Dependency ''dpddstr' Date is ''dpddval'"
$ !sh sym dpddat
$ !sh sym trgdat
$ !sh sym dpd
$ !sh sym trg
$!
$! turn off error messages for executing the directory command
$!
$ set mess/notext/nosever/nofac/noid
$! 
$! execute the directory command to check the dependency file date against
$! the target file date
$!
$ dir/out=nl:/since="''trgdval'"/'dpddstr' 'dpd'
$ stat=$status
$!
$! restore error messages
$!
$ set mess'messparam'
$ !sh sym stat
$!
$! check the directory status - if 1 then the command line set should be
$! executed
$!
$ if stat .eq. 1 then compile="YES"
$!
$! go back and get the next dependency file
$!
$ goto loop1
$!
$ loop1_done:
$!
$! no more dependency files - compile or skip the command set
$!
$ if compile .eqs. "NO" then goto loop
$!
$ make:
$!
$! make the target (execute the command lines)
$!
$ if statusflag .eqs. "YES" then write sys$output "VAX/MAKE: Making target"
$!
$ loop2:
$!
$! read each command line - should begin with at least one space
$! skip comment lines.  if no command lines exist then look for a rule
$! for the target extension and the 1st dependency extension.  command line
$! set is terminated by a blank line
$!
$ read/error=eof file line
$ lineno=lineno+1
$ if f$extract(0,1,line) .eqs. "!" then goto loop2
$ if f$length(line) .eq. 0 .and. rule .eq. 1 then goto do_rule
$ if f$length(line) .eq. 0 then goto loop
$ if f$extract(0,1,line) .eqs. " " then goto got_line
$ write sys$output " "
$ write sys$output "VAX/MAKE: Syntax error on line ''lineno'"
$ write sys$output "VAX/MAKE: Line is "+line
$ write sys$output "VAX/MAKE: Command line sets must be terminated by a blank line"
$ goto abort
$!
$ got_line:
$!
$! found a command line - echo and execute
$!
$ if statusflag .eqs. "YES" then write sys$output " "
$ if statusflag .eqs. "YES" then -
  write sys$output "VAX/MAKE: Command Line is "+line+" "+param
$ abort=0
$ rule=0
$ gosub do_line
$!
$! check to see if an error occured during the execution
$!
$ if abort .eq. 1 then goto abort
$!
$! go back and get the next command line
$!
$ goto loop2
$!
$ do_rule:
$!
$! find the rule based on the target & 1st dependency
$!
$ c=1
$ ruleloop1:
$ rulename="rule''c't"
$ !sh sym 'rulename'
$ !sh sym t1e
$ !sh sym d1e
$!
$! check a rule against the target extension
$!
$ if 'rulename' .nes. "''t1e'" then goto ruleloop1_bottom
$ rulename="rule''c'd"
$!
$! check a rule against the dependency extension
$!
$ if 'rulename' .nes. "''d1e'" then goto ruleloop1_bottom
$!
$! if we get here then the rule was found
$! get ready to execute the command lines
$!
$ if statusflag .eqs. "YES" then -
  write sys$output "VAX MAKE: Using rule for ''t1e' : ''d1e'"
$!
$! number of command lines is RULExN
$! each command line is RULExLy (1 thru RULExN value)
$!
$ n=1
$ rulename="rule''c'n"
$ rulemax='rulename'
$!
$ ruleloop2:
$!
$! execute the next command line
$!
$ rulename="rule''c'l''n'"
$ !sh sym 'rulename'
$ !line="''rulename'"
$ line='rulename'
$ if statusflag .eqs. "YES" then write sys$output " "
$ if statusflag .eqs. "YES" then -
  write sys$output "VAX/MAKE: Command Line is "+line+" "+param
$ abort=0
$ gosub do_line
$!
$! check to see if an error occured during the execution
$!
$ if abort .eq. 1 then goto abort
$ n=n+1
$!
$! go back and get the next command line
$!
$ if n .le. rulemax then goto ruleloop2
$!
$! no more command lines - go back and get the next line in the file
$!
$ goto loop
$!
$ ruleloop1_bottom:
$ c=c+1
$!
$! go back and check the next rule
$!
$ if c .le. ruleno then goto ruleloop1
$!
$! did not find a rule for this target spec
$!
$ write sys$output "VAX/MAKE: No rule found for ''t1e' : ''d1e'"
$!
$! go back and get the next line in the file
$!
$ goto loop
$!
$ do_line:
$!
$! execute a command line.  set up error trapping and set up the various
$! states (verify, etc.) based on the MAKE command line flags
$!
$ on severe_error then goto exec_done
$!
$! don't execute if requested not to
$!
$ if execflag .eqs. "NO" then goto exec_done
$!
$! set verify if requested
$!
$ if verifyflag .eqs. "YES" then set verify=(proc)
$ 'line' 'param'
$ exec_done:
$ exitstat=$status
$ if verifyflag .eqs. "YES" then set verify=(noproc)
$!
$! check error settings after execution
$!
$ on severe_error then goto ignore_error
$!
$! turn off error messages
$!
$ set mess/notext/nosever/nofac/noid
$!
$! check the return status
$!
$ gosub check_status
$!
$! restore error messages
$!
$ set mess'messparam'
$!
$ ignore_error:
$ severity=$severity
$ on severe_error then goto eof
$ !sh sym exitstat
$ !sh sym severity
$ if verifyflag .eqs. "YES" then set verify=(noproc)
$ if statusflag .eqs. "YES" .and. reportflag .eqs. "YES" then write sys$output "VAX/MAKE: Return from Command Line is ''exitstat'"
$ on severe_error then goto eof
$ if ignoreflag .eqs. "YES" then return
$ if .not. severity then abort=1
$!
$! done with command line execution
$!
$ return
$!
$ abort:
$!
$! MAKE run aborted
$!
$ write sys$output " "
$ write sys$output "VAX/MAKE Version ''makeversion' Aborted ''f$time()'"
$!
$ eof:
$!
$! clean up
$!
$ set mess'messparam'
$ if f$logical("file") .nes. "" then close file
$ if loop .eq. 2 then goto done
$ loop=2
$ goto outer_loop
$!
$ done:
$ write sys$output " "
$ write sys$output "VAX/MAKE Version ''makeversion' Finished ''f$time()'"
$ if reportflag .eqs. "NO" then exitstat=1
$ if pverifystate then set verify=(proc)
$ exit exitstat
$!
$ check_status:
$ return exitstat
$!
$ check_flags:
$ retstat=1
$ if FLG$F_D .eq. 0 then dateflag="NO"
$ if FLG$F_D .eq. 1 then dateflag="YES"
$ if FLG$F_E .eq. 0 then execflag="NO"
$ if FLG$F_E .eq. 1 then execflag="YES"
$ if FLG$F_I .eq. 0 then ignoreflag="NO"
$ if FLG$F_I .eq. 1 then ignoreflag="YES"
$ if FLG$F_R .eq. 0 then reportflag="NO"
$ if FLG$F_R .eq. 1 then reportflag="YES"
$ if FLG$F_S .eq. 0 then statusflag="NO"
$ if FLG$F_S .eq. 1 then statusflag="YES"
$ if FLG$F_V .eq. 0 then verifyflag="NO"
$ if FLG$F_V .eq. 1 then verifyflag="YES"
$ if FLG$F_P .eq. 1 then param="''FLG$V_P'"
$ if checkfile .eqs. "YES" .and. ARG1$V .eqs. "" then goto bad_argument
$ checkflag="C"
$ checkval="T"
$ checkvalue=FLG$V_C$T
$ trgdat=""
$ if FLG$V_C$T .eqs. "M" then trgdat="RDT"
$ if FLG$V_C$T .eqs. "C" then trgdat="CDT"
$ if FLG$V_C$T .eqs. "" then trgdat="CDT"
$ if FLG$V_C$T .eqs. "M" then trgdstr="Modified"
$ if FLG$V_C$T .eqs. "C" then trgdstr="Create"
$ if FLG$V_C$T .eqs. "" then trgdstr="Create"
$ if trgdat .eqs. "" .and. FLG$F_C .eq. 1 then goto bad_value
$ checkflag="C"
$ checkval="D"
$ checkval=FLG$V_C$D
$ dpddat=""
$ if FLG$V_C$D .eqs. "M" then dpddat="RDT"
$ if FLG$V_C$D .eqs. "C" then dpddat="CDT"
$ if FLG$V_C$D .eqs. "" then dpddat="CDT"
$ if FLG$V_C$D .eqs. "M" then dpddstr="Modified"
$ if FLG$V_C$D .eqs. "C" then dpddstr="Create"
$ if FLG$V_C$D .eqs. "" then dpddstr="Create"
$ if dpddat .eqs. "" .and. FLG$F_C .eq. 1 then goto bad_value
$ goto check_done
$!
$ bad_argument:
$ write sys$output "No MAKE filename specified."
$ goto abort_check
$!
$ bad_value:
$ write sys$output "Illegal value ''checkval' for flag ''checkflag' value ''checkval'"
$ goto abort_check
$!
$ abort_check:
$ retstat=%x38240
$!
$ check_done:
$!
$! report various flag settings
$!
$ if statusflag .eqs. "YES" then return retstat
$ write sys$output " "
$ write sys$output "VAX/MAKE Options in effect:"
$ x="NO YES"
$ write sys$output f$fao("   !25AS","Display File Dates:")+f$extract(FLG$F_D*3,3,x)
$ write sys$output f$fao("   !25AS","Execute Commands:")+f$extract(FLG$F_E*3,3,x)
$ write sys$output f$fao("   !25AS","Ignore Errors:")+f$extract(FLG$F_I*3,3,x)
$ write sys$output f$fao("   !25AS","Report Exit Status:")+f$extract(FLG$F_R*3,3,x)
$ write sys$output f$fao("   !25AS","Display Status Messages:")+f$extract(FLG$F_S*3,3,x)
$ write sys$output f$fao("   !25AS","Set Verify on Command:")+f$extract(FLG$F_V*3,3,x)
$ write sys$output f$fao("   !25AS","Pass Command Parameter:")+f$extract(FLG$F_P*3,3,x)
$ if FLG$V_C$T .eqs. "C" then -
  write sys$output f$fao("   !30AS","Target comparison date:")+"Create"
$ if FLG$V_C$T .eqs. "M" then -
  write sys$output f$fao("   !30AS","Target comparison date:")+"Modify"
$ if FLG$V_C$D .eqs. "C" then -
  write sys$output f$fao("   !30AS","Dependent comparison date:")+"Create"
$ if FLG$V_C$D .eqs. "M" then -
  write sys$output f$fao("   !25AS","Dependent comparison date:")+"Modify"
$ return retstat
